/* eslint-disable camelcase */
const UserModel = require('../../../models/UserModel')
const jwt = require('jsonwebtoken')
const fs = require('fs-extra')
const path = require('path')

const setServices = async (req, res, next) => {
  try {
    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')

    const decodedToken = jwt.verify(token, process.env.APP_SECRET)
    const user = await UserModel.findById(decodedToken.id)
    if (!user) {
      return res.status(422).json({
        error: true,
        message: 'شما دسترسی به این بخش ندارید'
      })
    }
    const { services } = req.body
    if (!services) {
      return res.status(422).json({
        error: true,
        message: 'اطلاعات ارسالی اشتباه است'
      })
    }

    // مدیریت تصاویر برای خدمات
    const servicesWithImages = []
    const parsedServices = JSON.parse(services) // پارس کردن رشته JSON به آرایه جاوا اسکریپت
    if (parsedServices && parsedServices.length > 0) {
      for (const service of parsedServices) {
        const serviceImages = []
        const serviceId = service.id
        if (req.files && req.files.serviceImages && req.files.serviceImages[serviceId]) {
          const imageFiles = Array.isArray(req.files.serviceImages[serviceId]) ? req.files.serviceImages[serviceId] : [req.files.serviceImages[serviceId]]
          const uploadDir = path.join(__dirname, '../../../../storage/services')
          if (!fs.existsSync(uploadDir)) {
            fs.mkdirSync(uploadDir, { recursive: true })
          }
          for (const imageFile of imageFiles) {
            const uniqueFileName = `${user.user_name}-${Date.now()}${Math.random().toString().slice(2, 11)}${path.extname(imageFile.name)}`
            const filePath = path.join(uploadDir, uniqueFileName)
            // await fs.promises.rename(imageFile.path, filePath)
            await fs.move(imageFile.path, filePath)
            const imageUrl = `/services/${uniqueFileName}`
            serviceImages.push(imageUrl)
            // به‌روزرسانی مسیر تصویر در آبجکت service
            service.image = imageUrl
          }
        } else {
          console.log('sss')
        }
        servicesWithImages.push({ ...service, images: serviceImages })
      }
    }

    user.services = servicesWithImages
    await user.save()

    return res.json({
      message: 'خدمات با موفقیت ثبت شد'
    })
  } catch (error) {
    next(error)
  }
}

const updateServices = async (req, res, next) => {
  try {
    const { height, weight, size } = req.body

    if (!height || !weight || !size) {
      return res.status(422).json({
        error: true,
        message: 'اطلاعات ارسالی اشتباه است'
      })
    }
    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')
    const decodedToken = jwt.verify(token, process.env.APP_SECRET)
    const userId = decodedToken.id
    // جستجوی کاربر
    const user = await UserModel.findById(userId)

    if (!user) {
      return res.status(404).json({
        error: true,
        message: 'کاربر یافت نشد'
      })
    }

    user.height = height
    user.weight = weight
    user.size = size
    await user.save()

    return res.json({
      message: 'سایز با موفقیت به‌روزرسانی شد'
    })
  } catch (error) {
    next(error)
  }
}
module.exports = {
  setServices, updateServices
}
